<template>
    <div class="dialog-table-container sub-page-inner">
        <div class="sub-page-detail full-detail">
            <el-table
                :element-loading-background="loadingColor"
                v-loading="loading"
                height="calc(100% - 20px)"
                align="center"
                :data="tableData"
                class="dialog_table"
                :cell-style="{'text-align': 'center'}"
                :header-cell-style="{'text-align': 'center'}"
            >
                <el-table-column
                    type="index"
                    label="序号"
                    width="100%"
                ></el-table-column>
                <el-table-column
                    prop="projectName"
                    label="项目名称"
                    width="400"
                >
                    <el-table-column prop="projectName" label="总计">
                        <template v-slot="{row}">
                            <div
                                style="cursor: pointer"
                                @click="
                                    handleDetail(
                                        'projectSubMonthPlan',
                                        '月度完成清单·' + row.projectName,
                                        row.projectId
                                    )
                                "
                            >
                                {{ row.projectName }}
                            </div>
                        </template>
                    </el-table-column>
                </el-table-column>
                <el-table-column
                    prop="currentMonthTotalNum"
                    label="本月计划数量"
                    width="180"
                >
                    <el-table-column
                        prop="currentMonthTotalNum"
                        :label="sum1 + ''"
                        width="180"
                    >
                        <template v-slot="{row}">
                            {{ row.currentMonthTotalNum || '-' }}
                        </template>
                    </el-table-column>
                </el-table-column>
                <el-table-column
                    prop="currentMonthFinishNum"
                    label="本月完成数量"
                    width="180"
                >
                    <el-table-column
                        prop="currentMonthFinishNum"
                        :label="sum2 + ''"
                        width="180"
                    >
                        <template v-slot="{row}">
                            {{
                                row.currentMonthTotalNum
                                    ? row.currentMonthFinishNum
                                    : '-'
                            }}
                        </template>
                    </el-table-column>
                </el-table-column>
                <el-table-column
                    prop="currentMonthFinishRate"
                    label="本月计划完成率"
                    width="180"
                >
                    <el-table-column
                        prop="currentMonthFinishRate"
                        :label="sum3"
                        width="180"
                    >
                        <template v-slot="{row}">
                            {{
                                row.currentMonthTotalNum
                                    ? row.currentMonthFinishRate + '%'
                                    : '-'
                            }}
                        </template>
                    </el-table-column>
                </el-table-column>
                <el-table-column
                    prop="upToMonthTotalNum"
                    label="累计计划数量"
                    width="180"
                >
                    <el-table-column
                        prop="upToMonthTotalNum"
                        :label="sum4 + ''"
                        width="180"
                    ></el-table-column>
                </el-table-column>
                <el-table-column
                    prop="upToMonthFinishNum"
                    label="累计完成数量"
                    width="180"
                >
                    <el-table-column
                        prop="upToMonthFinishNum"
                        :label="sum5 + ''"
                        width="180"
                    ></el-table-column>
                </el-table-column>
                <el-table-column
                    prop="upToMonthFinishRate"
                    label="累计计划完成率"
                    width="180"
                >
                    <el-table-column
                        prop="upToMonthFinishRate"
                        :label="sum6 + ''"
                        width="180"
                    >
                        <template v-slot="{row}">
                            {{ row.upToMonthFinishRate }}%
                        </template>
                    </el-table-column>
                </el-table-column>
                <el-table-column
                    prop="totalYearNum"
                    label="全年计划数量"
                    width="180"
                >
                    <el-table-column
                        prop="totalYearNum"
                        :label="sum7 + ''"
                        width="180"
                    ></el-table-column>
                </el-table-column>
                <el-table-column
                    prop="totalYearRate"
                    label="全年计划完成率"
                    width="180"
                >
                    <el-table-column
                        prop="totalYearRate"
                        :label="sum8"
                        width="180"
                    >
                        <template v-slot="{row}">
                            {{ row.totalYearRate }}%
                        </template>
                    </el-table-column>
                </el-table-column>
                <!-- <el-table-column prop="degree" label="完成情况" width="180">
                    <template v-slot="{ row }">
                        <el-tag v-if="row.degree == 1" type="success" effect="dark">已完成</el-tag>
                        <el-tag v-if="row.degree == 2" type="danger" effect="dark">未完成</el-tag>
                    </template>
                </el-table-column> -->
            </el-table>
            <!-- <table width="80%" height="40" cellspacing="0" align="center">
                <tr>
                    <td colspan="5" width="34%">总计</td>
                    <td width="11%">{{ sum1 }}</td>
                    <td width="11%">{{sum2}}</td>
                    <td width="11%">{{sum3}}</td>
                    <td width="11%">{{sum4}}</td>
                    <td width="11%">{{ sum5.toFixed(2) }}%</td>
                </tr>
            </table> -->
            <!-- <div style="font-size: 16PX;">备注：项目分发数=实际完成个数为优秀，项目分发数>实际完成个数且项目分发数-实际完成个数≤2为良好，项目分发数-实际完成个数>2为一般。</div> -->
        </div>
    </div>
</template>

<script>
import apiList from '@/api/bigScreen/majorView.js'
export default {
    props: {
        tableOptions: {
            type: Object,
            default: () => {
                return {}
            },
        },
    },
    data() {
        return {
            loading: false,
            loadingColor: 'rgba(6, 46, 106, 0.4)',
            tableData: [],
            sum1: 0,
            sum2: 0,
            sum3: '',
            sum4: 0,
            sum5: 0,
            sum6: '',
            sum7: 0,
            sum8: 0,
        }
    },
    beforeDestroy() {
        this.$bus.$off('changeDate')
    },
    mounted() {
        this.getData()
        this.$bus.$on('changeDate', (searchDate) => {
            this.getData()
        })
    },
    created() {
        this.$emit('searchDateChange')
    },
    methods: {
        getSummaries(param) {
            const {columns, data} = param
            const sums = []
            columns.forEach((column, index) => {
                if (index === 1 || index === 0 || index === 7) {
                    sums[index] = index === 1 ? '总计' : ''
                    return
                }
                const values = data.map((item) => Number(item[column.property]))
                if (!values.every((value) => isNaN(value))) {
                    sums[index] = values.reduce((prev, curr) => {
                        const value = Number(curr)
                        if (!isNaN(value)) {
                            return prev + curr
                        } else {
                            return prev
                        }
                    }, 0)
                }
                if (index === 6) {
                    sums[index] = ((sums[3] / sums[2]) * 100).toFixed(2) + '%'
                }
            })

            return sums
        },
        // 跳转成果榜
        handleDetail(comp, title, id) {
            this.$router.push({
                path: '/DetailComponent',
                name: 'DetailComponent',
                query: {
                    comp,
                    // type,
                    title,
                    projectId: id,
                },
            })
        },
        getData() {
            this.loading = true
            let data = JSON.parse(sessionStorage.getItem('searchDate'))
            console.log(data)
            // 综合
            apiList.getProjectStatistics(data, (res) => {
                this.tableData = res.value
                this.sum1 = 0
                this.sum2 = 0
                this.sum3 = ''
                this.sum4 = 0
                this.sum5 = 0
                this.sum6 = ''
                this.sum7 = 0
                this.sum8 = 0
                res.value.forEach((item) => {
                    this.sum1 += item.currentMonthTotalNum
                    this.sum2 += item.currentMonthFinishNum
                    this.sum4 += item.upToMonthTotalNum
                    this.sum5 += item.upToMonthFinishNum
                    this.sum7 += item.totalYearNum
                    // this.sum8 += item.totalYearRate
                })
                this.sum3 = ((this.sum2 / this.sum1) * 100).toFixed(2) + '%'
                this.sum6 = ((this.sum5 / this.sum4) * 100).toFixed(2) + '%'
                this.sum8 = ((this.sum5 / this.sum7) * 100).toFixed(2) + '%'
                this.loading = false
            })
        },
    },
}
</script>
<style lang="scss" scoped>
/deep/.el-table--border th.el-table__cell {
    border-bottom: 1px solid #01215a;
}
/deep/.el-table--border th {
    border: 1px solid #01215a !important;
    &:last-child {
        border: none !important;
    }
}
/deep/.el-table--border td{
    border-right: 0px solid #01215a !important;
}

/deep/.el-table--border th.el-table__cell.gutter:last-of-type {
    border: none;
}

/deep/.el-table--group,
.el-table--border {
    border: none;
}

/deep/.el-table--border::after {
    background: none;
}

.sub-page-detail.full-detail {
    * {
        font-size: 18PX !important;
    }

    width: 100% !important;
}

.column-item-rotate {
    display: inline-block;
    transform: rotateX(180deg);
}

.cqlt-icon-arrow {
    font-size: 18px;
}

.column-trend-icon-1 {
    color: #59c06c;
    text-shadow: #59c06c 1px 0 12px;
}

.column-trend-icon-2 {
    color: #fe3b30;
    text-shadow: #fe3b30 1px 0 12px;
}
</style>
<style lang="scss">@import './table.scss';</style>
